<?php
/************************************************************************
 * Copyright (C) 2013  Jan Altensen (Stricted)                          *
 *                                                                      *
 * This program is free software: you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation, either version 3 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program. If not, see <http://www.gnu.org/licenses/>. *
 *                                                                      *
 ************************************************************************
 *
 *  Bots/ZNCServ.class.php
 *
 * simple ZNC admin bot...
 *
 * you need to use this bot the ZNCAdmin script from pk910 you can find it here: http://git.pk910.de/?p=ZNCAdmin.git;a=summary
 *
 */
class {$_NAME} extends Bot {
	private $uplink;
	private $znc;
	private $topic = false;
	
	public function load($uplink, $old = false) {
		$this->uplink = $uplink;
		if(!$old) {
			$nick = "ZNCServ";
			$ident = "ZNCServ";
			$host = "services.massivegamesnet.net";
			$ip = "127.0.0.1";
			$realname = "ZNCServ";
			$modes = "ioknISDr ZNCServ";
			$this->znc = $this->uplink->addUser($nick,$ident,$host,$ip,$modes,$realname);
			if(is_a($this->znc, "P10_User")) {
				$this->uplink->join($this->znc, "#opers", P10_Channel::USERPRIV_OPED);
				$this->uplink->join($this->znc, "#znc", P10_Channel::USERPRIV_OPED);
				$this->uplink->join($this->znc, "#staff", P10_Channel::USERPRIV_OPED);
				$this->uplink->join($this->znc, "#support", P10_Channel::USERPRIV_OPED);
			}
		} else {
			$this->znc = $old;
		}
		
		ModCMD::bind($this, BIND_CHANMSG, "recive_privmsg");
		ModCMD::bind($this, BIND_QUIT, "recive_quit");
	}
	
	public function unload($rehash = false) {
		if($rehash) {
			return $this->znc;
		} else {
			$this->uplink->delUser($this->znc, "Bye.");
		}
	}
	
	public function loop() {
		
	}
	
	public function recive_privmsg($user, $channel, $message) {
		$op = false;
		$schannel = P10_Channel::getChannelByName("#staff");
		if($schannel) {
			$privs = $schannel->getUserPrivs($user);
			$op = ($privs & P10_Channel::USERPRIV_OPED);
		}
		if(!$user->getModes()->hasMode('o') && !$op) return 0;
		$exp=explode(" ", $message, 3);
		switch (strtolower($exp[0])) {
			case "~znc":
				switch (strtolower($exp[1])) {
					case "add":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php add ".$exp[2]);
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					case "del":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php del ".$exp[2]);
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					case "list":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php search all");
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					case "resetpass":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php resetpass ".$exp[2]);
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					case "seen":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php seen ".$exp[2]." ".$exp[3]);
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
					case "whois":
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php search ".$exp[2]);
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					case "simul":
						$exp=explode(" ", $message, 4);
						$ret = shell_exec("cd scripts/ZNCAdmin/ && php zncadmin.php simul ".$exp[2]." '".$exp[3]."'");
						$ret = explode("\n",$ret);
						foreach($ret as $line) {
							if($line != "")
								$this->uplink->notice($this->znc, $user, $line);
						}
						break;
					default:
						$this->uplink->notice($this->znc, $user, "subcommands: add, del, list, seen, whois, simul, resetpass");
						break;
				}
				break;

		}
		return 0;
	}
	
	public function recive_quit($user, $reason) {
		if($user === $this->znc) {
			$this->load($this->uplink);
		}
	}

}
?>
